;Input:		Var(HL),Var(DE)
;Output:	Var(HL) = int Var(HL)/Var(DE)
;			Var(DE) preserved
;			RemVar = TempVar = remainder
;			CF = C if var(DE) = 0, else CF = NC
;			A,BC,DE,HL destroyed

DivideVar64:
 ld (SaveHL),hl	;save address of var(HL)
 ld (SaveDE),de	;save address of var(DE)
 push hl
 ZERO(RemVar)	;remainder = 0
 pop hl

 call LengthVar	;E = length of var(HL)
 ret z			;if var(HL) = 0, return
 ld a,e
 add a,a
 add a,a
 add a,a
 ld b,a			;counter = length * 8 (how many bits to push out)
 ld a,8
 sub e			;A = how many rotating loops to skip
 ld e,a
 add a,a
 add a,e		; * 3
 ld e,a
 ld hl,RLVar
 add hl,de
 ld (&DV64_RLVar+1),hl	;save address to call to into routine below

 ld hl,(SaveDE)	;HL = var(DE)
 call LengthVar	;E = length of var(DE)
 scf
 ret z			;if var(DE) = 0, division by zero, so set CF and return
 ld a,8
 sub e
 jr z,DV64_SkipDec
 dec a
DV64_SkipDec:	;A = how many rotating and subtracting loops to skip
 ld c,a
 add a,a
 add a,c		; * 3
 ld e,a
 ld hl,RLVar
 add hl,de
 ld (&DV64_RLRem+1),hl	;save address of new rotating call
 add a,c
 add a,c		; * 5
 ld e,a
 ld hl,SbcVar
 add hl,de
 ld (&DV64_Sbc+1),hl		;save address of new subtracting call

DV64_Loop:
 push bc
 ld hl,(SaveHL)
 or a
DV64_RLVar:
 call RLVar+0	;rotate left bit out of dividend
 ld hl,RemVar
DV64_RLRem:
 call RLVar+0	;rotate into remainder
 LD_VAR(TempVar, RemVar)	;copy remainder into temp var
 ld hl,(SaveDE)
 ld de,TempVar
 or a
DV64_Sbc:
 call SbcVar+0	;temp var = remainder - divisor
 jr c,DV64_NextBit	;if divisor > remainder, jump
 ld de,RemVar
 ld hl,TempVar
 ld c,8
 ldir			;copy result of sub back into remainder
 ld hl,(SaveHL)
 inc (hl)		;set bit 0 of dividend (later quotient)
DV64_NextBit:
 pop bc
 djnz DV64_Loop
 or a
 ret
