;Initiates jump/relocation table for 64-bit math function calls
;Original idea by Erik Huizing.
;Input:		CallTab	=	function addresses to relocate
;		JumpTab	=	location of jump table

InitJumpTab:
 ld hl,&CallTab	;HL -> addresses to relocate
 ld de,JumpTab	;DE -> where jumps go to link to functions
 ld a,(CallTabEnd-CallTab)/2	;number of functions to relocate
IJT_Loop:
 push hl
 push af
 call LD_HL_MHL	;HL = (HL) = address to relocate
 pop af
 ld bc,(PROGRAM_ADDR)	;BC = address of program
 add hl,bc		;add so HL -> function
 ex de,hl		;HL -> jump table
 ld (hl),jp_op		;opcode for <jp>
 inc hl
 ld (hl),e
 inc hl
 ld (hl),d		;load in relocated address of function
 inc hl
 ex de,hl		;switch back
 pop hl
 inc hl
 inc hl			;HL -> next address
 dec a
 jr nz,IJT_Loop	;decrease counter, repeat
 ret


;addresses to relocate:
CallTab:
.dw FindRoot64
.dw ExponentVar64
.dw MultiplyVar64
.dw MultiplyVar8
.dw DivideVar64
.dw DivideVar8
.dw InputVar
.dw DisplayVar
CallTabEnd:

JumpTab		=	TEXT_MEM2	;location to jump table
FindRoot64R	=	0*3+JumpTab
ExponentVar64R	=	1*3+JumpTab
MultiplyVar64R	=	2*3+JumpTab
MultiplyVar8R	=	3*3+JumpTab
DivideVar64R	=	4*3+JumpTab
DivideVar8R	=	5*3+JumpTab
InputVarR	=	6*3+JumpTab
DisplayVarR	=	7*3+JumpTab
