;Input:		Var(HL)
;			(CURSOR_ROW),(CURSOR_COL) = row,column
;Output:	Var(HL) is inputted with a non-zero number

InputVar:
 ld (SaveHL),hl
 call ZeroVar	;var(HL) = 0
IV_Loop:
 halt
 call GET_KEY
 or a
 jr z,IV_Loop	;loop until key press
 cp K_ENTER		;ENTER?
 jr nz,IV_NotDone	;if not ENTER, check if number key
 ld hl,(SaveHL)	;HL -> var
 call ChZeroVar	;var(HL) = 0?
 ret nz			;if var(HL) != 0, then something was inputted
 jr IV_Loop		;else, loop back
IV_NotDone:
 ld hl,&NumberTable+9	;HL -> number-key table
 ld bc,10		;number of scancodes to check through
 cpdr			;comparing...
 jr nz,IV_Loop	;if no match, no number-key pressed, so return
 ld a,c			;else, C = number pressed (0 - 9)
 ld hl,(SaveHL)	;HL -> var
 push af
 add a,'0'
 call TX_CHARPUT	;display number char
 ld a,10
 push hl
 call MultiplyVar8R	;multiply var(HL) by 10, result in ProdVar
 pop hl
 push hl
 call ZeroVar	;var(HL) = 0
 pop de
 pop af
 ld (de),a		;var(HL) = number pressed
 ld hl,ProdVar
 call AddVar	;add to product, then get new key
 jr IV_Loop

NumberTable:
.db $21,$22,$1A,$12,$23,$1B,$13,$24,$1C,$14


;Input:	Var(HL)
;		(CURSOR_ROW),(CURSOR_COL) = row,column
;Output:	Var(HL) displayed

DisplayVar:
 ld de,TempVar
 ld bc,8
 ldir
 ld de,BCDBuffEnd
 xor a
 ld (de),a
DV_Loop:
 push de
 DIV8(TempVar, 10)
 pop de
 dec de
 add a,'0'
 ld (de),a
 CHZERO(TempVar)
 jr nz,DV_Loop
 ex de,hl
 jp D_ZT_STR
