;Macros for 64-bit functions

;var1 = var2
;204 cc
#define LD_VAR(var1,var2)	ld hl,var2\ ld de,var1\ ld bc,8\ ldir

;var = A
;136 cc
#define LD_A(var)	ld hl,var\ ld (hl),a\ xor a\ call ZeroVar+2

;var = x (8-bit)
;139 cc
#define LD_XB(var,x)	ld hl,var\ ld (hl),x\ xor a\ call ZeroVar+2

;var1 <-> var2
;337 cc
#define EX(var1,var2)	ld de,var1\ ld hl,var2\ call ExVar

;var = 0
;125 cc
#define ZERO(var)	ld hl,var\ call ZeroVar

;shifts var left
;189 cc
#define SL(var)	ld hl,var\ call SLVar

;rotates var left
;185 cc
#define RL(var)	ld hl,var\ call RLVar

;shifts var right
;210 cc
#define SR(var)	ld hl,var\ call SRVar

;rotates var right
;181 cc
#define RR(var)	ld hl,var+7\ call RRVar+4

;var = var + 1
;49 - 188 cc
#define INC(var)	ld hl,var\ call IncVar

;var = var - 1
;63 - 244 cc
#define DEC(var)	ld hl,var\ call DecVar

;compares var2 to var1 (var1-var2)
;61 - 250 cc
#define CP(var1,var2)	ld de,var1+7\ ld hl,var2+7\ call CPVar+6

;checks if var is zero
;48 - 160 cc
#define CHZERO(var)	ld hl,var\ call ChZeroVar

;var1 = var1 + var2
;265 cc
#define ADD(var1,var2)	ld de,var1\ ld hl,var2\ call AddVar

;var1 = var1 + var2 + CF
;261 cc
#define ADC(var1,var2)	ld de,var1\ ld hl,var2\ call AdcVar

;var = var + A
;34 - 73 - 212 cc
#define ADD8_A(var)	ld hl,var\ add a,(hl)\ ld (hl),a\ call c,IncVar+2

;var = var + A + CF
;34 - 73 - 212 cc
#define ADC8_A(var)	ld hl,var\ adc a,(hl)\ ld (hl),a\ call c,IncVar+2

;var = var + x
;41 - 80 - 219 cc
#define ADD8(var,x)	ld hl,var\ ld a,x\ add a,(hl)\ ld (hl),a\ call c,IncVar+2

;var = var + x + CF
;41 - 80 - 219 cc
#define ADC8(var,x)	ld hl,var\ ld a,x\ adc a,(hl)\ ld (hl),a\ call c,IncVar+2

;var1 = var1 - var2
;209 cc
#define SUB(var1,var2)	ld de,var1\ ld hl,var2\ call SubVar

;var1 = var1 - var2 - CF
;205 cc
#define SBC(var1,var2)	ld de,var1\ ld hl,var2\ call SbcVar

;points HL to highest non-zero byte in var (starting from end)
;E = first non-zero byte number (8 = MSByte; 1 = LSByte; but 0 if var = 0)
;74 - 198 cc
#define LENGTH(var)	ld hl,var\ call LengthVar

;copies x bytes from var2 to var1
;46 + 21 * x cc
#define LD_VAR_SHORT(x,var1,var2)	ld hl,var2\ ld de,var1\ ld bc,x\ ldir

;checks only if lower x bytes of var = 0
;32 + 16 * x cc
#define CHZERO_SHORT(x,var)	xor a\ ld hl,var\ call ((8-x)*3)+1+ChZeroVar
