;Input:		var(HL)
;Output:	TempVar = 0
;			RootVar = int sqrt var(HL)
;			RemVar = TempVar2 = remainder

#define FR64RLVAR(var)		ld hl,var\ call VarFuncJP1
#define FR64RL(var)			ld hl,var\ call VarFuncJP2

FindRoot64:
 ld de,TempVar
 push de
 ld bc,8
 ldir
 ZERO(RootVar)
 ZERO(RemVar)
 pop hl
 call LengthVar	;E = length of number, in bytes
 ret z
 ld a,e
 add a,a
 add a,a
 ld b,a		;define counter (B = 4 * length)
 ld a,8
 ld c,e		;save length
 sub e		;A = how many loops to skip in RLVar
 ld e,a
 add a,a
 add a,e
 ld e,a		;E = how far to jump into the RLVar func (3 * loops)
 ld hl,RLVar
 add hl,de	;add to address of function
 ld (VarFuncJP1+1),hl	;store behind "jp" op
 ld a,c
 rra
 sub 8
 cpl		;A = 8 - (length / 2 + 1)
 ld c,a		;A = how many loops to skip for rotating root and rem
 add a,a
 add a,c
 ld e,a
 ld hl,RLVar
 add hl,de
 ld (VarFuncJP2+1),hl
 add a,c
 add a,c
 ld e,a
 ld hl,SbcVar
 add hl,de
 ld (FR64_Sbc+1),hl

FR64_Loop:
 push bc
 or a
 FR64RLVAR(TempVar)	;shift number left
 FR64RL(RemVar)		;rotate remainder left
 FR64RLVAR(TempVar)	;shift number left
 FR64RL(RemVar)		;rotate remainder left
 FR64RL(RootVar)	;append 0 to root
 LD_VAR_SHORT(5, TempVar2, RemVar)	;copy remainder into temp var
 ld de,TempVar2
 ld hl,RootVar
FR64_Sbc:
 call SbcVar+0		;subtract root from temp var
 jr c,FR64_NoFit	;if root > remainder, jump
 CHZERO_SHORT(5, TempVar2)	;check if temp var = 0
 jr z,FR64_NoFit	;if root = remainder, jump
 ld hl,RootVar
 inc (hl)
 inc (hl)			;set bit 1 and res bit 0 of root
 DEC(TempVar2)		;decrease temp var
 LD_VAR_SHORT(5, RemVar, TempVar2)	;copy temp var back into remainder
FR64_NoFit:
 pop bc
 djnz FR64_Loop
 ld hl,RootVar
 jp SRVar		;shift root right to get correct root